



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>BZOJ1018 堵塞的交通(线段树)</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">BZOJ1018 堵塞的交通(线段树)</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-03 06:04:35 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>题目很好明白，然后实现很神奇。首先如果考虑并查集的话，对于删边和加边操作我们无法同时进行。然后暴力分块的话，复杂度是O(n sqrt n) ，不是很优。于是看了题解，发现了线段树的神奇用途。</p>
<p>我们维护每个矩形四个顶点的六个变量，分别是：</p>
<p>g[0]：表示第一行左右端点的连通性。</p>
<p>g[1]：表示第二行左右端点的连通性。</p>
<p>g[2]：左上端点和左下端点的连通性。</p>
<p>g[3]：右上端点和右下端点的连通性。</p>
<p>g[4]：左上端点和右下端点的连通性。</p>
<p>g[5]：左下端点和右上端点的连通性。</p>
<p>这六个变量做好之后就可以合并矩形了。同样是这六个变量，合并的时候需要费点事，考虑一下各种情况。</p>
<p>最后需要的一点就是可能出现的特殊情况，<img referrerpolicy="no-referrer"src="https://images2017.cnblogs.com/blog/1134155/201801/1134155-20180115143318084-529522663.png" />这样的怎么办？</p>
<p>我们考虑全面即可，查询的时候不光查询一个区间，还需要查询两头的区间，然后判断是否会出现这种情况，就是我写的solve函数里面判断答案的后三种情况。 &mdash;&mdash;by VANE</p>
<div>
<pre class="prettyprint linenums">#include&lt;bits/stdc++.h&gt;<br />
using namespace std;<br />
const int N=;<br />
struct node{bool g[];};<br />
int n;<br />
node s[],t[N*];<br />
bool m[N*];<br />
int calc(int x,int y){return x*(n-)+y;}<br />
void build(int rt,int l,int r)<br />
{<br />
    if(l==r) {t[rt]=s[];return;}<br />
    int mid=l+r&gt;&gt;;<br />
    build(rt&lt;&lt;,l,mid);<br />
    build(rt&lt;&lt;|,mid+,r);<br />
}<br />
node merge(node a,node b,bool x,bool y)<br />
{<br />
    node c;<br />
    c.g[]=(a.g[]&amp;&amp;x&amp;&amp;b.g[])||(a.g[]&amp;&amp;y&amp;&amp;b.g[]);<br />
    c.g[]=(a.g[]&amp;&amp;y&amp;&amp;b.g[])||(a.g[]&amp;&amp;x&amp;&amp;b.g[]);<br />
    c.g[]=(a.g[])||(a.g[]&amp;&amp;x&amp;&amp;b.g[]&amp;&amp;y&amp;&amp;a.g[]);<br />
    c.g[]=(b.g[])||(b.g[]&amp;&amp;x&amp;&amp;a.g[]&amp;&amp;y&amp;&amp;b.g[]);<br />
    c.g[]=(a.g[]&amp;&amp;x&amp;&amp;b.g[])||(a.g[]&amp;&amp;y&amp;&amp;b.g[]);<br />
    c.g[]=(b.g[]&amp;&amp;x&amp;&amp;a.g[])||(b.g[]&amp;&amp;y&amp;&amp;a.g[]);<br />
    return c;<br />
}<br />
void insert(int rt,int l,int r,int x,int y,int xx,int yy,bool c)<br />
{<br />
    int mid=l+r&gt;&gt;;<br />
    if(x==xx&amp;&amp;y==mid)<br />
    {<br />
        m[calc(x,y)]=c;<br />
        t[rt]=merge(t[rt&lt;&lt;],t[rt&lt;&lt;|],m[calc(,mid)],m[calc(,mid)]);<br />
        return;<br />
    }<br />
    else if(x!=xx&amp;&amp;l==r){t[rt]=s[c];return;}<br />
    if(y&lt;=mid) insert(rt&lt;&lt;,l,mid,x,y,xx,yy,c);<br />
    if(y&gt;mid) insert(rt&lt;&lt;|,mid+,r,x,y,xx,yy,c);<br />
    t[rt]=merge(t[rt&lt;&lt;],t[rt&lt;&lt;|],m[calc(,mid)],m[calc(,mid)]);<br />
}<br />
node query(int rt,int l,int r,int ll,int rr)<br />
{<br />
    int mid=r+l&gt;&gt;;<br />
    if(l&gt;=ll&amp;&amp;r&lt;=rr) return t[rt];<br />
    if(rr&lt;=mid)return query(rt&lt;&lt;,l,mid,ll,rr);<br />
    if(ll&gt;mid) return query(rt&lt;&lt;|,mid+,r,ll,rr);<br />
    return merge(query(rt&lt;&lt;,l,mid,ll,rr),query(rt&lt;&lt;|,mid+,r,ll,rr),m[calc(,mid)],m[calc(,mid)]);<br />
}<br />
void solve(int x,int y,int xx,int yy)<br />
{<br />
    bool ans;<br />
    s[]=query(,,n,,y);<br />
    s[]=query(,,n,y,yy);<br />
    s[]=query(,,n,yy,n);<br />
    if(x==xx) ans=(s[].g[x])||(s[].g[]&amp;&amp;s[].g[+x^])||(s[].g[]&amp;&amp;s[].g[+x])||(s[].g[]&amp;&amp;s[].g[]&amp;&amp;s[].g[x^]);<br />
    else ans=(s[].g[+x])||(s[].g[]&amp;&amp;s[].g[x^])||(s[].g[]&amp;&amp;s[].g[x])||(s[].g[]&amp;&amp;s[].g[+x^]&amp;&amp;s[].g[]);<br />
    if(ans) puts("Y");<br />
    else puts("N");

}<br />
int main()<br />
{<br />
    scanf("%d",&amp;n);<br />
    s[]=(node){,,,,,};<br />
    s[]=(node){,,,,,};<br />
    memset(t,,sizeof t);<br />
    memset(m,,sizeof m);<br />
    build(,,n);<br />
    char ch[];scanf("%s",ch);<br />
    while(ch[]!='E')<br />
    {<br />
        int x,y,xx,yy;scanf("%d%d%d%d",&amp;x,&amp;y,&amp;xx,&amp;yy);<br />
        if(y&gt;yy) swap(x,xx),swap(y,yy);<br />
        x--;xx--;<br />
        if(ch[]=='O') insert(,,n,x,y,xx,yy,);<br />
        else if(ch[]=='C') insert(,,n,x,y,xx,yy,);<br />
        else solve(x,y,xx,yy);<br />
        scanf("%s",ch);<br />
    }<br />
}</pre>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/2q7e0j9e.html">漫谈C&num;编程语言在游戏领域的应用</a>
		</li>
						<li><a href="https://www.batexi.com/a/g8e4mke9.html">WPF - 属性系统 （1 of 4）</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8o5jkp9.html">Making my own Autonomous Robot in ROS &sol; Gazebo&comma; Day 1&colon; Building the static model</a>
		</li>
						<li><a href="https://www.batexi.com/a/90v47nj8.html">setting bundle 多语言，本地化，系统设置</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7m1yvkq.html">C&num; Chart圖標綁定</a>
		</li>
						<li><a href="https://www.batexi.com/a/qydj6rjq.html">跳跃表Skip List【附java实现】</a>
		</li>
						<li><a href="https://www.batexi.com/a/8z15ydd9.html">Hat&amp;&num;39&semi;s Fibonacci（大数，好）</a>
		</li>
						<li><a href="https://www.batexi.com/a/8med550q.html">linux服务器安装php GD扩展库方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jzvz008.html">通过 PHP 连接China Azure Blob 存储</a>
		</li>
						<li><a href="https://www.batexi.com/a/93yrlow8.html">keycloak管理用户权限</a>
		</li>
						<li><a href="https://www.batexi.com/a/950kl3e8.html">C&num;WebService 出现No &amp;&num;39&semi;Access-Control-Allow-Origin&amp;&num;39&semi; header is present on the requested resource</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdp427zq.html">Java并发之CountDownLatch工具类</a>
		</li>
						<li><a href="https://www.batexi.com/a/95g0gjvq.html">CentOS使用nginx部署https服务</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1rk1pz8.html">BaseDao&period;util&lpar;虎大将军&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdwjy609.html">Spring Security（二十五）：7&period; Sample Applications</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j1oplg9.html">学习笔记20&mdash;MATLAB特殊函数</a>
		</li>
						<li><a href="https://www.batexi.com/a/8m2g7k2q.html">10&period;scrapy入门</a>
		</li>
						<li><a href="https://www.batexi.com/a/qx2kxld8.html">MySQL C API的一个让我头疼的问题&comma;获得一行记录中包括NULL</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2kermoq.html">bootstrap之输入框组</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pmenl49.html">docker1&period;13新功能上要关注的点</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/9jmw2lg9.html">JavaScript 秘密花园&mdash;&mdash;对象的使用和属性操作</a>
			</li>
						<li><a href="https://www.batexi.com/a/qve6rm19.html">【Hadoop】大数据时代，我们为什么使用hadoop</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7e6g5g9.html">LintCode 402&colon; Continuous Subarray Sum</a>
			</li>
						<li><a href="https://www.batexi.com/a/8zkd3mx8.html">【洛谷 P2120】 &lbrack;ZJOI2007&rsqb;仓库建设（斜率优化）</a>
			</li>
						<li><a href="https://www.batexi.com/a/qx2p6208.html">【译】Linux提权基础</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwl1noy9.html">2017ACM暑期多校联合训练 - Team 7 1010    HDU 6129   Just do it        &lpar;找规律&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/9534znm8.html">LintCode之硬币排成线</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1v0yg0q.html">VC连接access</a>
			</li>
						<li><a href="https://www.batexi.com/a/8koydorq.html">java类中访问属性</a>
			</li>
						<li><a href="https://www.batexi.com/a/qx2p43z8.html">75&period;VS2013和opencv3&period;1&period;0开发环境配置</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
